# m1node #

A thin layer of utils for working with [node.js](http://nodejs.org/)

## Features ##

* Built on [express](http://expressjs.com/)
* [CouchDB](http://couchdb.apache.org/) support via [node-couchdb](http://github.com/felixge/node-couchdb)
* Configuration and URL patterns similar to [Django](http://docs.djangoproject.com)
* Database configuration for CouchDB including design document management and change monitoring
* [Redis](http://code.google.com/p/redis/) backed sessions via [connect-redis](http://github.com/visionmedia/connect-redis/)

## Dependencies ##

* [express](http://expressjs.com/)
* [connect](http://github.com/senchalabs/connect)
* Everything else is in [package.json](http://github.com/mikebannister/m1node/blob/master/package.json) and can be installed via npm

## To do ##

* eliminate need for _messages.html in each project, allow overriding
* make errors in development mode show everything and suppress everything in production 
* look into using connect middleware including: errorHandler
* tests for couchdb change monitor, couchdb design document change detection, template configuration, messages view helper

## Credits ##

Based largely on the [MVC example](http://github.com/visionmedia/express/tree/master/examples/mvc/) that comes with express.
