var fs = require('fs'),
    spawn = require('child_process').spawn,
    underscore = require('underscore'),
    strings = require('underscore.strings'),
    argv = require('optimist').argv;
    
_.mixin({
    isDefined: function(val) {
        return !_.isUndefined(val);
    }
});

objFromJsonFile = exports.objFromJsonFile = function(filePath) {
    var objStr;
    try {
        objStr = fs.readFileSync(filePath, 'utf8');
    } catch(err) {
        return null;
    }
    return JSON.parse(objStr);
};

getOptions = exports.getOptions = function() {
    var opts = {};
    if (argv.f || argv.flush) {
        opts.flush = argv.f || argv.flush;
    }
    if (argv.v || argv.verbose) {
        opts.verbose = argv.v || argv.verbose;
    }
    return opts;
};
