var namespaces = require('namespaces'), 
    profile = require('../profile');

module.exports = {
    handleProfile: function(req, res, next) {
        var username = req.session.username;
        var autoLoadAppSetting = _.isUndefined(req.app.set('autoLoadProfile')) || req.app.set('autoLoadProfile');
        var autoLoadRouteSetting = _.isUndefined(req.extras.autoLoadProfile) || req.extras.autoLoadProfile;

        // use writehead to save profile after request completes
        var writeHead = res.writeHead;
        res.writeHead = function(status, headers) {
            if (req.profile && autoLoadAppSetting && autoLoadRouteSetting) {
                req.profile.save();
            }
            // pass through
            res.writeHead = writeHead;
            return res.writeHead(status, headers);
        };

        if (!username) {
            next();
        } else {
            if (autoLoadAppSetting && autoLoadRouteSetting) {
                req.profile = new Profile(username);
                req.profile.addListener('ready', function() {
                    next();
                });
            } else {
                next();
            }
        }
    }
};
