var underscore = require('underscore'),
    helpers = require('./helpers'),
    couchdb = require('couchdb');

var Store = function(conf) {
    var client = couchdb.createClient(
        conf.port,
        conf.host, 
        conf.username, 
        conf.password
    );
    var database = client.db(conf.name);
    return {
        getKey: function() {
            return conf.key;
        },
        getClient: function() {
            return client;
        },
        getConf: function() {
            return conf;
        },
        getDatabase: function() {
            return database;
        }
    };
};

Stores = exports.Stores = function(settings, authFile) {
    if (!settings) {
        throw new Error('settings argument is required');
    }
    var self = this;
    var passwords, key, password, defaults;
    if (authFile) {
        passwords = objFromJsonFile(authFile);
    }
    var confs = [];
    settings = _.isArray(settings) ? settings : [settings];
    _.each(settings, function(conf) {
        key = conf.key;
        if (passwords && passwords[conf.username]) {
            conf.password = passwords[conf.username].password;
        }
        defaults = {
            port: 5984,
            host: 'localhost'
        };
        conf = _.extend(defaults, conf);
        confs.push(conf);
    });
    _.each(confs, function(conf) {
        self[conf.key] = new Store(conf);
    });
};
