var helpers = require('m1node/helpers'),
    assert = require('assert'),
    path = require('path'),
    should = require('should');

module.exports = {
    'isDefined mixin with defined value': function(done) {
        var val = 0;
        assert.ok(_.isDefined(val), "isDefined should return true for value: 0");
        done();
    },
    'isDefined mixin with undefined value': function(done) {
        var val;
        assert.ok(!_.isDefined(val), "isDefined should return false for uninitialied variable");
        done();
    },
    'objFromJsonFile returns valid JSON obj with expected values': function(done) {
        var jsonFilePath = path.join(__dirname, '/../example/minimal/auth.conf');
        var obj = objFromJsonFile(jsonFilePath);
        assert.type(obj, 'object', 'objFromJsonFile should return an valid object');
        assert.type(obj.m1node1, 'object', 'objFromJsonFile key should reference a valid object');
        assert.type(obj.m1node1.password, 'string', 'objFromJsonFile key should reference a string');
        assert.eql(obj.m1node1.password, 'm1nodeTest', 'objFromJsonFile key should reference the appropriate string');
        done();
    },
    'objFromJsonFile returns null for non-existent file': function(done) {
        var nonexistentJsonFilePath = path.join(__dirname, '/files/nonexistent');
        var obj = objFromJsonFile(nonexistentJsonFilePath);
        assert.isNull(obj, 'objFromJsonFile should return null for non-existent file');
        done();
    },
    'getOptions with no options set': function(done) {    
        // NOTE: would love to do some tests for checking when these values are set
        // but munging process.argv only works once with optimist
        var opts = getOptions();
        assert.ok(!opts.verbose, 'verbose should not be true');
        assert.ok(!opts.flush, 'flush should not be true');
        done();
    }
};
